library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

entity Debenc is
    Port ( clk    : in  STD_LOGIC;
           encin  : in  STD_LOGIC_VECTOR(1 downto 0);
           r	   : out  STD_LOGIC;
			  l	   : out  STD_LOGIC);
end Debenc;


architecture Behavioral of Debenc is
signal level0, level1, en_fall0, en_fall1: std_logic := '0';
signal count0, count1: integer range 0 to 255 := 0;

begin

r <= '1' when en_fall1 = '1' and level0 = '1' else '0';
l <= '1' when en_fall0 = '1' and level1 = '1' else '0';

process
variable en_sr0, en_sr1 : std_logic_vector (3 downto 0) := "0000";
	begin
   wait until rising_edge(clk);
	
	en_fall0 <= not en_sr0(2) and en_sr0(3);
	en_sr0 := en_sr0(2 downto 0) & level0;
	
	en_fall1 <= not en_sr1(2) and en_sr1(3);
   en_sr1 := en_sr1(2 downto 0) & level1;
	
	
	if 	count0 < 255 and encin(0) = '1' then
			count0 <= count0 +1;
	elsif count0 >   0 and encin(0) = '0' then
			count0 <= count0 -1;
	end if;
	if 	count0 < 16 then
			level0 <= '0';
	elsif count0 > 238 then
			level0 <= '1';
	end if;
	
	if 	count1 < 255 and encin(1) = '1' then
			count1 <= count1 +1;
	elsif count1 >   0 and encin(1) = '0' then
			count1 <= count1 -1;
	end if;
	if 	count1 < 16 then
			level1 <= '0';
	elsif count1 > 238 then
			level1 <= '1';
	end if;

end process;
end Behavioral;

