library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

entity vga is
  port(clk75_in, bin  : in std_logic;
		 horizontal_counter : out std_logic_vector (10 downto 0);
		 vertical_counter   : out std_logic_vector (9 downto 0);
       red_out   : out std_logic_vector(2 downto 0);
       green_out : out std_logic_vector(2 downto 0);
       blue_out  : out std_logic_vector(1 downto 0);
       hs_out    : out std_logic;
       vs_out    : out std_logic);
end vga;

architecture Behavioral of vga is

signal hc: integer range 0 to 1328;
signal vc: integer range 0 to 806;

begin
horizontal_counter <= std_logic_vector(to_unsigned(hc,11));
vertical_counter <= std_logic_vector(to_unsigned(vc,10));

--BILD begint bei Sync-pulse
process
begin
  wait until rising_edge(clk75_in);
    if (hc >= 280 ) -- 280 = Sync-pulse + Back-porch
    and (hc < 1304 ) -- 1304 = Sync-pulse + Back-porch + Visible-area
    and (vc >= 35 ) -- 35 = Sync-pulse + Back-porch
    and (vc < 803 ) -- 803 = Sync-pulse + Back-porch + Visible-area
    then
		if bin = '1' then
			red_out <= "111";
			green_out <= "111";
			blue_out <= "11";
		elsif bin = '0' then
			red_out <= "000";
			green_out <= "000";
			blue_out <= "00";
		end if;
--      red_out <= "111" when bin='1' else "000"; --horizontal_counter(3 downto 0) 
--																--  and vertical_counter(3 downto 0);
--      green_out <= "111" when bin='1' else "000"; --horizontal_counter(6 downto 4) 
--																--  and vertical_counter(6 downto 4);
--      blue_out <= "111" when bin ='1' else "000"; --horizontal_counter(9 downto 7) 
--																--  and vertical_counter(9 downto 7);
    else
      red_out <= "000";
      green_out <= "000";
      blue_out <= "00";
    end if;
    if (hc > 0 )
      and (hc < 136 ) -- 136 = Sync-pulse
    then
      hs_out <= '0';
    else
      hs_out <= '1';
    end if;
    if (vc > 0 )
      and (vc < 6 ) -- 6 = Sync-pulse
    then
      vs_out <= '0';
    else
      vs_out <= '1';
    end if;
    hc <= hc + 1;
    if (hc = 1328) then --1328 = Whole-line
      vc <= vc + 1;
      hc <= 0;
    end if;
    if (vc = 806) then	--806	= Whole-frame    
      vc <= 0;
    end if;
end process;

end Behavioral;


